/* (c) Sinelabore Software Tools GmbH - All rights reserved. Reproduction, modification,
   use or disclosure to third parties without express
   authority is forbidden. Generator running in demo mode!
   Please purchase a license if you want to use this software in projects.
 */

/* Command line options: -l java -p ssc -o src/demo/Sm sm.xml   */
/* This file is generated from sm.xml - do not edit manually  */
/* Generated on: Wed Jun 01 20:23:05 CEST 2022 / Version 5.5.5 */


package demo;

public class Sm extends SmBase
{

	public enum States {
		InState1,
		InState2,
		InState3,
		__UNKNOWN_STATE__
	}

	public enum Events  {
		evButtonClickedState3,
		evButtonClickedState2,
		evButtonClickedState1,
		SM_NO_MSG
	}


	// flag if initialized
	protected boolean m_initialized=false;

	States stateVar;
	
	// State handler class default ctor
	public Sm()
	{
	}

	/* Helper(s) to reset history */
	
	/* Helper to get innermost active state id */
	public States getInnermostActiveState() {
		if(isInInState3()){
			return States.InState3;
		}else if(isInInState2()){
			return States.InState2;
		}else if(isInInState1()){
			return States.InState1;
		}else{
			return States.__UNKNOWN_STATE__;
		}
	}

	// Helper(s) to find out if the machine is in a certain state
	public boolean isInInState1(){return (((stateVar== States.InState1)) ? (true) : (false));}
	public boolean isInInState2(){return (((stateVar== States.InState2)) ? (true) : (false));}
	public boolean isInInState3(){return (((stateVar== States.InState3)) ? (true) : (false));}




	// Reinitialize the state machine
	public void reInitialize(){
			m_initialized=false;
			initialize();
	}

	public void initialize(){

		if(m_initialized==false){

			m_initialized=true;

			// Set state vars to default states
			stateVar = States.InState1; /* set init state of top state */


			//call on entry code of default states
			setText("Entering State1\n");
			


		}

	}

	protected void smChangeToState(States state){
		stateVar=state;
	}

	


	public int processEvent(Events msg){

		int evConsumed = 0;

		

		if(m_initialized==false) return 0;


		switch (stateVar) {

			case InState1:
				if(msg==Events.evButtonClickedState2){
					/* Transition from InState1 to InState2 */
					/* OnExit code of state InState1 */
					setText("Leaving State1\n");

					/* OnEntry code of state InState2 */
					setText("Entering State2\n");

					/* adjust state variables  */
					stateVar = States.InState2;
				}else if(msg==Events.evButtonClickedState3){
					/* Transition from InState1 to InState3 */
					/* OnExit code of state InState1 */
					setText("Leaving State1\n");

					/* OnEntry code of state InState3 */
					setText("Entering State3\n");

					/* adjust state variables  */
					stateVar = States.InState3;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case InState1  */

			case InState2:
				if(msg==Events.evButtonClickedState1){
					/* Transition from InState2 to InState1 */
					/* OnExit code of state InState2 */
					setText("Leaving State2\n");

					/* OnEntry code of state InState1 */
					setText("Entering State1\n");

					/* adjust state variables  */
					stateVar = States.InState1;
				}else if(msg==Events.evButtonClickedState3){
					/* Transition from InState2 to InState3 */
					/* OnExit code of state InState2 */
					setText("Leaving State2\n");

					/* OnEntry code of state InState3 */
					setText("Entering State3\n");

					/* adjust state variables  */
					stateVar = States.InState3;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case InState2  */

			case InState3:
				if(msg==Events.evButtonClickedState1){
					/* Transition from InState3 to InState1 */
					/* OnExit code of state InState3 */
					setText("Leaving State3\n");

					/* OnEntry code of state InState1 */
					setText("Entering State1\n");

					/* adjust state variables  */
					stateVar = States.InState1;
				}else if(msg==Events.evButtonClickedState2){
					/* Transition from InState3 to InState2 */
					/* OnExit code of state InState3 */
					setText("Leaving State3\n");

					/* OnEntry code of state InState2 */
					setText("Entering State2\n");

					/* adjust state variables  */
					stateVar = States.InState2;
				}else{
					/* Intentionally left blank */
				} /*end of event selection */
			break; /* end of case InState3  */

			default:
				/* Intentionally left blank */
			break;
		} /* end switch stateVar_root */
		return evConsumed;
	}
}
